<?php

/**
 * Functions which enhance the theme by hooking into WordPress
 *
 * @package auto_mechanic
 */

function auto_mechanic_body_classes( $auto_mechanic_classes ) {
	// Adds a class of hfeed to non-singular pages.
	if ( ! is_singular() ) {
		$auto_mechanic_classes[] = 'hfeed';
	}

	// Adds a class of no-sidebar when there is no sidebar present.
	if ( ! is_active_sidebar( 'sidebar-1' ) ) {
		$auto_mechanic_classes[] = 'no-sidebar';
	}

	$auto_mechanic_classes[] = auto_mechanic_sidebar_layout();

	return $auto_mechanic_classes;
}
add_filter( 'body_class', 'auto_mechanic_body_classes' );

/**
 * Add a pingback url auto-discovery header for single posts, pages, or attachments.
 */
function auto_mechanic_pingback_header() {
	if ( is_singular() && pings_open() ) {
		printf( '<link rel="pingback" href="%s">', esc_url( get_bloginfo( 'pingback_url' ) ) );
	}
}
add_action( 'wp_head', 'auto_mechanic_pingback_header' );


/**
 * Get all posts for customizer Post content type.
 */
function auto_mechanic_get_post_choices() {
	$auto_mechanic_choices = array( '' => esc_html__( '--Select--', 'auto-mechanic' ) );
	$auto_mechanic_args    = array( 'numberposts' => -1 );
	$auto_mechanic_posts   = get_posts( $auto_mechanic_args );

	foreach ( $auto_mechanic_posts as $auto_mechanic_post ) {
		$auto_mechanic_id             = $auto_mechanic_post->ID;
		$auto_mechanic_title          = $auto_mechanic_post->post_title;
		$auto_mechanic_choices[ $auto_mechanic_id ] = $auto_mechanic_title;
	}

	return $auto_mechanic_choices;
}

/**
 * Get all pages for customizer Page content type.
 */
function auto_mechanic_get_page_choices() {
	$auto_mechanic_choices = array( '' => esc_html__( '--Select--', 'auto-mechanic' ) );
	$auto_mechanic_pages   = get_pages();

	foreach ( $auto_mechanic_pages as $auto_mechanic_page ) {
		$auto_mechanic_choices[ $auto_mechanic_page->ID ] = $auto_mechanic_page->post_title;
	}

	return $auto_mechanic_choices;
}

if ( ! function_exists( 'auto_mechanic_excerpt_length' ) ) :
	/**
	 * Excerpt length.
	 */
	function auto_mechanic_excerpt_length( $auto_mechanic_length ) {
		if ( is_admin() ) {
			return $auto_mechanic_length;
		}

		return get_theme_mod( 'auto_mechanic_excerpt_length', 20 );
	}
endif;
add_filter( 'excerpt_length', 'auto_mechanic_excerpt_length', 999 );

if ( ! function_exists( 'auto_mechanic_excerpt_more' ) ) :
	/**
	 * Excerpt more.
	 */
	function auto_mechanic_excerpt_more( $auto_mechanic_more ) {
		if ( is_admin() ) {
			return $auto_mechanic_more;
		}

		return '&hellip;';
	}
endif;
add_filter( 'excerpt_more', 'auto_mechanic_excerpt_more' );

if ( ! function_exists( 'auto_mechanic_sidebar_layout' ) ) {
	/**
	 * Get sidebar layout.
	 */
	function auto_mechanic_sidebar_layout() {
		$auto_mechanic_sidebar_position      = get_theme_mod( 'auto_mechanic_sidebar_position', 'right-sidebar' );
		$auto_mechanic_sidebar_position_post = get_theme_mod( 'auto_mechanic_post_sidebar_position', 'right-sidebar' );
		$auto_mechanic_sidebar_position_page = get_theme_mod( 'auto_mechanic_page_sidebar_position', 'right-sidebar' );

		if ( is_home() ) {
			$auto_mechanic_sidebar_position = $auto_mechanic_sidebar_position_post;
		} elseif ( is_page() ) {
			$auto_mechanic_sidebar_position = $auto_mechanic_sidebar_position_page;
		}

		return $auto_mechanic_sidebar_position;
	}
}

if ( ! function_exists( 'auto_mechanic_is_sidebar_enabled' ) ) {
	/**
	 * Check if sidebar is enabled.
	 */
	function auto_mechanic_is_sidebar_enabled() {
		$auto_mechanic_sidebar_position      = get_theme_mod( 'auto_mechanic_sidebar_position', 'right-sidebar' );
		$auto_mechanic_sidebar_position_post = get_theme_mod( 'auto_mechanic_post_sidebar_position', 'right-sidebar' );
		$auto_mechanic_sidebar_position_page = get_theme_mod( 'auto_mechanic_page_sidebar_position', 'right-sidebar' );

		$auto_mechanic_sidebar_enabled = true;
		if ( is_single() || is_archive() || is_search() ) {
			if ( 'no-sidebar' === $auto_mechanic_sidebar_position ) {
				$auto_mechanic_sidebar_enabled = false;
			}
		} elseif ( is_home() ) {
			if ( 'no-sidebar' === $auto_mechanic_sidebar_position || 'no-sidebar' === $auto_mechanic_sidebar_position_post ) {
				$auto_mechanic_sidebar_enabled = false;
			}
		} elseif ( is_page() ) {
			if ( 'no-sidebar' === $auto_mechanic_sidebar_position || 'no-sidebar' === $auto_mechanic_sidebar_position_page ) {
				$auto_mechanic_sidebar_enabled = false;
			}
		}
		return $auto_mechanic_sidebar_enabled;
	}
}

if ( ! function_exists( 'auto_mechanic_get_homepage_sections ' ) ) {
	/**
	 * Returns homepage sections.
	 */
	function auto_mechanic_get_homepage_sections() {
		$auto_mechanic_sections = array(
			'banner'  => esc_html__( 'Banner Section', 'auto-mechanic' ),
			'car-services' => esc_html__( 'Car Services Section', 'auto-mechanic' ),
		);
		return $auto_mechanic_sections;
	}
}

/**
 * Renders customizer section link
 */
function auto_mechanic_section_link( $auto_mechanic_section_id ) {
	$auto_mechanic_section_name      = str_replace( 'auto_mechanic_', ' ', $auto_mechanic_section_id );
	$auto_mechanic_section_name      = str_replace( '_', ' ', $auto_mechanic_section_name );
	$auto_mechanic_starting_notation = '#';
	?>
	<span class="section-link">
		<span class="section-link-auto_mechanic_title"><?php echo esc_html( $auto_mechanic_section_name ); ?></span>
	</span>
	<style type="text/css">
		<?php echo $auto_mechanic_starting_notation . $auto_mechanic_section_id; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>:hover .section-link {
			visibility: visible;
		}
	</style>
	<?php
}

/**
 * Adds customizer section link css
 */
function auto_mechanic_section_link_css() {
	if ( is_customize_preview() ) {
		?>
		<style type="text/css">
			.section-link {
				visibility: hidden;
				background-color: black;
				position: relative;
				top: 80px;
				z-index: 99;
				left: 40px;
				color: #fff;
				text-align: center;
				font-size: 20px;
				border-radius: 10px;
				padding: 20px 10px;
				text-transform: capitalize;
			}

			.section-link-auto_mechanic_title {
				padding: 0 10px;
			}

			.banner-section {
				position: relative;
			}

			.banner-section .section-link {
				position: absolute;
				top: 100px;
			}
		</style>
		<?php
	}
}
add_action( 'wp_head', 'auto_mechanic_section_link_css' );

/**
 * Breadcrumb.
 */
function auto_mechanic_breadcrumb( $auto_mechanic_args = array() ) {
	if ( ! get_theme_mod( 'auto_mechanic_enable_breadcrumb', true ) ) {
		return;
	}

	$auto_mechanic_args = array(
		'show_on_front' => false,
		'show_title'    => true,
		'show_browse'   => false,
	);
	breadcrumb_trail( $auto_mechanic_args );
}
add_action( 'auto_mechanic_breadcrumb', 'auto_mechanic_breadcrumb', 10 );

/**
 * Add separator for breadcrumb trail.
 */
function auto_mechanic_breadcrumb_trail_print_styles() {
	$auto_mechanic_breadcrumb_separator = get_theme_mod( 'auto_mechanic_breadcrumb_separator', '/' );

	$auto_mechanic_style = '
		.trail-items li::after {
			content: "' . $auto_mechanic_breadcrumb_separator . '";
		}'; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped

	$auto_mechanic_style = apply_filters( 'auto_mechanic_breadcrumb_trail_inline_style', trim( str_replace( array( "\r", "\n", "\t", '  ' ), '', $auto_mechanic_style ) ) );

	if ( $auto_mechanic_style ) {
		echo "\n" . '<style type="text/css" id="breadcrumb-trail-css">' . $auto_mechanic_style . '</style>' . "\n"; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
	}
}
add_action( 'wp_head', 'auto_mechanic_breadcrumb_trail_print_styles' );

/**
 * Pagination for archive.
 */
function auto_mechanic_render_posts_pagination() {
	$auto_mechanic_is_pagination_enabled = get_theme_mod( 'auto_mechanic_enable_pagination', true );
	if ( $auto_mechanic_is_pagination_enabled ) {
		$auto_mechanic_pagination_type = get_theme_mod( 'auto_mechanic_pagination_type', 'default' );
		if ( 'default' === $auto_mechanic_pagination_type ) :
			the_posts_navigation();
		else :
			the_posts_pagination();
		endif;
	}
}
add_action( 'auto_mechanic_posts_pagination', 'auto_mechanic_render_posts_pagination', 10 );

/**
 * Pagination for single post.
 */
function auto_mechanic_render_post_navigation() {
	the_post_navigation(
		array(
			'prev_text' => '<span>&#10229;</span> <span class="nav-title">%title</span>',
			'next_text' => '<span class="nav-title">%title</span> <span>&#10230;</span>',
		)
	);
}
add_action( 'auto_mechanic_post_navigation', 'auto_mechanic_render_post_navigation' );

/**
 * Adds footer copyright text.
 */

function auto_mechanic_output_footer_copyright_content() {
    $auto_mechanic_theme_data = wp_get_theme();
    $auto_mechanic_copyright_text = get_theme_mod('auto_mechanic_footer_copyright_text');

    if (!empty($auto_mechanic_copyright_text)) {
        $auto_mechanic_text = $auto_mechanic_copyright_text;
    } else {
        $auto_mechanic_default_text = '<a href="'. esc_url(__('https://asterthemes.com/products/free-auto-repair-wordpress-theme','auto-mechanic')) . '" target="_blank"> ' . esc_html($auto_mechanic_theme_data->get('Name')) . '</a>' . '&nbsp;' . esc_html__('by', 'auto-mechanic') . '&nbsp;<a target="_blank" href="' . esc_url($auto_mechanic_theme_data->get('AuthorURI')) . '">' . esc_html(ucwords($auto_mechanic_theme_data->get('Author'))) . '</a>';
        /* translators: %s: WordPress.org URL */
		$auto_mechanic_default_text .= sprintf(esc_html__(' | Powered by %s', 'auto-mechanic'), '<a href="' . esc_url(__('https://wordpress.org/', 'auto-mechanic')) . '" target="_blank">WordPress</a>. ');

        $auto_mechanic_text = $auto_mechanic_default_text;
    }
    ?>
    <span><?php echo wp_kses_post($auto_mechanic_text); ?></span>
    <?php
}
add_action('auto_mechanic_footer_copyright', 'auto_mechanic_output_footer_copyright_content');

/* Footer Social Icons */ 
function auto_mechanic_footer_social_links() {

    if ( get_theme_mod('auto_mechanic_enable_footer_icon_section', true) ) {

            ?>
            <div class="socialicons">
				<div class="asterthemes-wrapper">
					<?php if ( get_theme_mod('auto_mechanic_footer_facebook_link', 'https://www.facebook.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('auto_mechanic_footer_facebook_link', 'https://www.facebook.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('auto_mechanic_facebook_icon', 'fab fa-facebook-f')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Facebook', 'auto-mechanic'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('auto_mechanic_footer_twitter_link', 'https://x.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('auto_mechanic_footer_twitter_link', 'https://x.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('auto_mechanic_twitter_icon', 'fab fa-twitter')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Twitter', 'auto-mechanic'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('auto_mechanic_footer_instagram_link', 'https://www.instagram.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('auto_mechanic_footer_instagram_link', 'https://www.instagram.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('auto_mechanic_instagram_icon', 'fab fa-instagram')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Instagram', 'auto-mechanic'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('auto_mechanic_footer_linkedin_link', 'https://in.linkedin.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('auto_mechanic_footer_linkedin_link', 'https://in.linkedin.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('auto_mechanic_linkedin_icon', 'fab fa-linkedin')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Linkedin', 'auto-mechanic'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('auto_mechanic_footer_youtube_link', 'https://www.youtube.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('auto_mechanic_footer_youtube_link', 'https://www.youtube.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('auto_mechanic_youtube_icon', 'fab fa-youtube')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Youtube', 'auto-mechanic'); ?></span>
						</a>
					<?php } ?>
				</div>
            </div>
            <?php
    }
}
add_action('wp_footer', 'auto_mechanic_footer_social_links');

if ( ! function_exists( 'auto_mechanic_footer_widget' ) ) :
	function auto_mechanic_footer_widget() {
		$auto_mechanic_footer_widget_column = get_theme_mod('auto_mechanic_footer_widget_column','4');

		$auto_mechanic_column_class = '';
		if ($auto_mechanic_footer_widget_column == '1') {
			$auto_mechanic_column_class = 'one-column';
		} elseif ($auto_mechanic_footer_widget_column == '2') {
			$auto_mechanic_column_class = 'two-columns';
		} elseif ($auto_mechanic_footer_widget_column == '3') {
			$auto_mechanic_column_class = 'three-columns';
		} else {
			$auto_mechanic_column_class = 'four-columns';
		}
	
		if($auto_mechanic_footer_widget_column !== ''): 
		?>
		<div class="dt_footer-widgets <?php echo esc_attr($auto_mechanic_column_class); ?> wow bounceInUp delay-1000" data-wow-duration="2s">
			<div class="footer-widgets-column">
				<?php
				$footer_widgets_active = false;

				// Loop to check if any footer widget is active
				for ($i = 1; $i <= $auto_mechanic_footer_widget_column; $i++) {
					if (is_active_sidebar('auto-mechanic-footer-widget-' . $i)) {
						$footer_widgets_active = true;
						break;
					}
				}

				if ($footer_widgets_active) {
					// Display active footer widgets
					for ($i = 1; $i <= $auto_mechanic_footer_widget_column; $i++) {
						if (is_active_sidebar('auto-mechanic-footer-widget-' . $i)) : ?>
							<div class="footer-one-column">
								<?php dynamic_sidebar('auto-mechanic-footer-widget-' . $i); ?>
							</div>
						<?php endif;
					}
				} else {
				?>
				<div class="footer-one-column default-widgets">
					<aside id="search-2" class="widget widget_search default_footer_search">
						<div class="widget-header">
							<h4 class="widget-title"><?php esc_html_e('Search Here', 'auto-mechanic'); ?></h4>
						</div>
						<?php get_search_form(); ?>
					</aside>
				</div>
				<div class="footer-one-column default-widgets">
					<aside id="recent-posts-2" class="widget widget_recent_entries">
						<h2 class="widget-title"><?php esc_html_e('Recent Posts', 'auto-mechanic'); ?></h2>
						<ul>
							<?php
							$recent_posts = wp_get_recent_posts(array(
								'numberposts' => 5,
								'post_status' => 'publish',
							));
							foreach ($recent_posts as $post) {
								echo '<li><a href="' . esc_url(get_permalink($post['ID'])) . '">' . esc_html($post['post_title']) . '</a></li>';
							}
							wp_reset_query();
							?>
						</ul>
					</aside>
				</div>
				<div class="footer-one-column default-widgets">
					<aside id="recent-comments-2" class="widget widget_recent_comments">
						<h2 class="widget-title"><?php esc_html_e('Recent Comments', 'auto-mechanic'); ?></h2>
						<ul>
							<?php
							$recent_comments = get_comments(array(
								'number' => 5,
								'status' => 'approve',
							));
							foreach ($recent_comments as $comment) {
								echo '<li><a href="' . esc_url(get_comment_link($comment)) . '">' .
									/* translators: %s: details. */
									sprintf(esc_html__('Comment on %s', 'auto-mechanic'), get_the_title($comment->comment_post_ID)) .
									'</a></li>';
							}
							?>
						</ul>
					</aside>
				</div>
				<div class="footer-one-column default-widgets">
					<aside id="calendar-2" class="widget widget_calendar">
						<h2 class="widget-title"><?php esc_html_e('Calendar', 'auto-mechanic'); ?></h2>
						<?php get_calendar(); ?>
					</aside>
				</div>
			</div>
			<?php } ?>
		</div>
		<?php
		endif;
	}
	endif;
add_action( 'auto_mechanic_footer_widget', 'auto_mechanic_footer_widget' );

function auto_mechanic_footer_text_transform_css() {
    $auto_mechanic_footer_text_transform = get_theme_mod('footer_text_transform', 'none');
    ?>
    <style type="text/css">
        .site-footer h4,footer#colophon h2.wp-block-heading,footer#colophon .widgettitle,footer#colophon .widget-title {
            text-transform: <?php echo esc_html($auto_mechanic_footer_text_transform); ?>;
        }
    </style>
    <?php
}
add_action('wp_head', 'auto_mechanic_footer_text_transform_css');